package net.nighttale.scheduling;

import org.quartz.CronTrigger;
import org.quartz.Job;
import org.quartz.JobDetail;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.Scheduler;
import org.quartz.SchedulerFactory;

public class QuartzReport implements Job {
	
    public void execute(JobExecutionContext context)
      throws JobExecutionException {
		System.out.println("Generating report - " + context.getJobDetail().getJobDataMap().get("type"));
		//throw new JobExecutionException();
		//TODO Generate report
	}	

	public static void main(String[] args) {
	  try {
		  SchedulerFactory schedFact = new org.quartz.impl.StdSchedulerFactory();
		  Scheduler sched = schedFact.getScheduler();
		  sched.start();
		  JobDetail jobDetail = new JobDetail("Income Report",
											"Report Generation",
	                                        QuartzReport.class);
	      jobDetail.getJobDataMap().put("type", "FULL");
	      sched.addGlobalJobListener(new MyJobFailedListener());
		  CronTrigger trigger = new CronTrigger("Income Report", "Report Generation");
		  //trigger.setCronExpression("0 0 12 ? * SUN");
		  trigger.setCronExpression("0/1 * * * * ?");
		  sched.scheduleJob(jobDetail, trigger);
		  System.out.println(trigger.getNextFireTime());
	  } catch (Exception e) {
	  	e.printStackTrace();
	  }
	}
	

}

