package net.nighttale.scheduling.web;

import java.io.IOException;

import javax.servlet.*;
import org.quartz.*;
import org.quartz.ee.ejb.EJBInvokerJob;
import org.quartz.impl.StdSchedulerFactory;

public class ReportServlet implements Servlet {

	/**
	 * @see javax.servlet.Servlet#init(ServletConfig)
	 */
	public void init(ServletConfig arg0) throws ServletException {
		  JobDetail jobDetail = new JobDetail("Income Report",
											"Report Generation",
	                                        EJBInvokerJob.class);
	      jobDetail.getJobDataMap().put("ejb", "java:comp/env/ejb/Report");
	      jobDetail.getJobDataMap().put("method", "generateReport");
	      Object[] args = new Object[0];
	      jobDetail.getJobDataMap().put("args", args);
		  CronTrigger trigger = new CronTrigger("Income Report", "Report Generation");
		  try {
		  	//trigger.setCronExpression("0 0 12 ? * SUN");
		  	trigger.setCronExpression("0/1 * * * * ?");
		  	Scheduler sched = StdSchedulerFactory.getDefaultScheduler();
			sched.scheduleJob(jobDetail, trigger);
		  } catch (Exception e) {
		  	e.printStackTrace();
		  }
	}

	/**
	 * @see javax.servlet.Servlet#getServletConfig()
	 */
	public ServletConfig getServletConfig() {
		return null;
	}

	/**
	 * @see javax.servlet.Servlet#service(ServletRequest, ServletResponse)
	 */
	public void service(ServletRequest arg0, ServletResponse arg1)
		throws ServletException, IOException {
	}

	/**
	 * @see javax.servlet.Servlet#getServletInfo()
	 */
	public String getServletInfo() {
		return null;
	}

	/**
	 * @see javax.servlet.Servlet#destroy()
	 */
	public void destroy() {
	}

}
